<template>
	<view class="choose">
		<view class="choosebg">
			<img v-show="!showStep4" class="title" src="https://ikea-mrm.woaap.com/images/mask/step3.png" />
			<img v-show="showStep4" class="step4" src="https://ikea-mrm.woaap.com/images/mask/step4.png" />
			<view class="swiperbox" id="box" :style="{ background: `url(${diybg})`, 'background-size': '100%' }" @click="touch">
				<img class="diybg" :src="animal" />
				<!-- 笑容元素 -->
				<view class="smile1" id="smile1" v-if="nchoose == 1">
					<img
						:src="smileObj.imgUrl"
						alt=""
						:style="
							'transform:rotate(' +
								smileObj.angle +
								'deg);left:' +
								smileObj.left +
								'px;top:' +
								smileObj.top +
								'px;width:' +
								smileObj.zoom * smileObj.width +
								'px;height:' +
								smileObj.zoom * smileObj.height +
								'px'
						"
						catchtouchstart="touch.start"
						catchtouchmove="touch.move"
						catchtouchend="touch.end"
						catchtouchcancel="touch.cancel"
					/>
				</view>
				<view class="smile2" id="smile1" v-if="nchoose == 2">
					<img
						:src="smileObj.imgUrl"
						alt=""
						:style="
							'transform:rotate(' +
								smileObj.angle +
								'deg);left:' +
								smileObj.left +
								'px;top:' +
								smileObj.top +
								'px;width:' +
								smileObj.zoom * smileObj.width +
								'px;height:' +
								smileObj.zoom * smileObj.height +
								'px'
						"
						catchtouchstart="touch.start"
						catchtouchmove="touch.move"
						catchtouchend="touch.end"
						catchtouchcancel="touch.cancel"
					/>
				</view>
				<view class="smile3" id="smile1" v-if="nchoose == 3">
					<img
						:src="smileObj.imgUrl"
						alt=""
						:style="
							'transform:rotate(' +
								smileObj.angle +
								'deg);left:' +
								smileObj.left +
								'px;top:' +
								smileObj.top +
								'px;width:' +
								smileObj.zoom * smileObj.width +
								'px;height:' +
								smileObj.zoom * smileObj.height +
								'px'
						"
						catchtouchstart="touch.start"
						catchtouchmove="touch.move"
						catchtouchend="touch.end"
						catchtouchcancel="touch.cancel"
					/>
				</view>
				<view class="smile4" id="smile1" v-if="nchoose == 4">
					<img
						:src="smileObj.imgUrl"
						alt=""
						:style="
							'transform:rotate(' +
								smileObj.angle +
								'deg);left:' +
								smileObj.left +
								'px;top:' +
								smileObj.top +
								'px;width:' +
								smileObj.zoom * smileObj.width +
								'px;height:' +
								smileObj.zoom * smileObj.height +
								'px'
						"
						catchtouchstart="touch.start"
						catchtouchmove="touch.move"
						catchtouchend="touch.end"
						catchtouchcancel="touch.cancel"
					/>
				</view>

				<!-- 文字和装饰 -->
				<view
					class="demos"
					:class="{ demosActived: item.id == demoId }"
					v-for="item in demos"
					:key="item.id"
					:id="item.id"
					:style="
						'transform:rotate(' +
							item.angle +
							'deg);left:' +
							item.left +
							'px;top:' +
							item.top +
							'px;width:' +
							(item.zoom * item.width + 10) +
							'px;height:' +
							(item.zoom * item.height + 10) +
							'px'
					"
					:catchtouchstart="item.start"
					:catchtouchmove="item.move"
					:catchtouchend="item.end"
					:catchtouchcancel="item.cancel"
				>
					<img class="dimg" :src="item.imgurl" :style="'width:' + item.zoom * item.width + 'px;height:' + item.zoom * item.height + 'px'" alt="" />
					<img class="close" v-if="item.id == demoId" src="https://ikea-mrm.woaap.com/images/mask/diy/close.png" alt="" />
				</view>
			</view>

			<img v-show="!showStep4" @click="gopost" class="gopost" src="https://ikea-mrm.woaap.com/images/mask/diy/gopost.png" alt="" />

			<!-- 底部选项卡选择元素 -->
			<view class="bottombox" v-show="!showStep4">
				<view class="tabs">
					<view class="tab-item" @click="chooseTab(1)">
						<img class="tab1" v-if="tabIndex != 1" src="https://ikea-mrm.woaap.com/images/mask/diy/1-0.png" />
						<img class="tab1" v-if="tabIndex == 1" src="https://ikea-mrm.woaap.com/images/mask/diy/1-1.png" />
					</view>
					<view class="border"></view>
					<view class="tab-item" @click="chooseTab(2)">
						<img v-if="tabIndex != 2" src="https://ikea-mrm.woaap.com/images/mask/diy/2-0.png" />
						<img v-if="tabIndex == 2" src="https://ikea-mrm.woaap.com/images/mask/diy/2-1.png" />
					</view>
					<view class="border"></view>
					<view class="tab-item" @click="chooseTab(3)">
						<img v-if="tabIndex != 3" src="https://ikea-mrm.woaap.com/images/mask/diy/3-0.png" />
						<img v-if="tabIndex == 3" src="https://ikea-mrm.woaap.com/images/mask/diy/3-1.png" />
					</view>
				</view>
				<view class="tab-content">
					<view class="content-list" v-if="tabIndex == 1">
						<view @click="chooseSmile(item, '笑容', index)" :class="{ item_actived: smileIndex == index }" class="content-item" v-for="(item, index) in tabArr1" :key="item.id">
							<view class="smile-img"><image :style="{ width: item.width + 'rpx', height: item.height + 'rpx' }" :src="item.imgUrl" mode="aspectFit"></image></view>
							<view class="name" v-html="item.name"></view>
						</view>
					</view>
					<view class="content-list" v-if="tabIndex == 2">
						<view @click="chooseDemos(item, '装饰', index)" class="content-item2" v-for="(item, index) in tabArr2" :key="item.id">
							<image class="img" :src="item.imgUrl" mode="aspectFit"></image>
						</view>
					</view>
					<view class="content-list" v-if="tabIndex == 3">
						<view @click="chooseDemos(item, '文字', index)" class="content-item2" v-for="(item, index) in tabArr3" :key="item.id">
							<image class="img" :src="item.imgUrl" mode="aspectFit"></image>
						</view>
					</view>
				</view>
			</view>

			<painter class="painter" :dirty="true" v-if="palette != null" :palette="palette" @imgOK="onImgOK" @imgErr="onImgErr"></painter>

			<!-- <painter class="painter"  :dirty="true"  :palette="palette" @imgOK="onImgOK"  @imgErr="onImgErr"></painter> -->
		</view>
		<view class="step4bg" v-if="showStep4">
			<img class="tips" src="https://ikea-mrm.woaap.com/images/mask/diy/text.png" />
			<view class="btngroup">
				<img @click="getSaveImgAuth" src="https://ikea-mrm.woaap.com/images/mask/diy/save.png" />
				<img @click="goLight" src="https://ikea-mrm.woaap.com/images/mask/diy/light.png" />
			</view>
			<view class="popup" v-if="isshowpop">
				<view class="popmain">
					<img @click="isshowpop = false" class="close" src="https://ikea-mrm.woaap.com/images/mask/close.png" />
					<img class="popicon" src="https://ikea-mrm.woaap.com/images/mask/popicon1.png" />
					<img @click="okay" class="btn" src="https://ikea-mrm.woaap.com/images/mask/diy/ok.png" />
				</view>
			</view>
		</view>
	</view>
</template>

<script>
import YrobotTouch from '../../static/utils/YrobotTouch.js'; //引入YrobotTouch
export default {
	data() {
		return {
			saveImgUrl: '',
			showStep4: false,
			canvasScale: 3,
			showPost: false,
			tabIndex: 1,
			diybg: '',
			animal: '',
			smileIndex: -1,
			nchoose: 0,
			demoId: '',
			index: 0,
			palette: {},
			isshowpop: true,
			smileObj: {
				width: 0,
				height: 0,
				left: 0,
				top: 0,
				angle: 0,
				zoom: 1,
				imgUrl: '',
				name: ''
			},
			smileBox: '',
			box: '',
			demos: [],
			tabArr1: [
				{
					id: 'tab1_1',
					name: 'RISÖ<br/>丽索',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab1/1.png',
					width: 123,
					height: 61
				},
				{
					id: 'tab1_2',
					name: 'LUSTIGT<br/>卢斯蒂格',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab1/2.png',
					width: 109,
					height: 55
				},
				{
					id: 'tab1_3',
					name: 'SMILA<br/>斯米拉马奈',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab1/3.png',
					width: 80,
					height: 57
				},
				{
					id: 'tab1_4',
					name: 'BLÅHAJ<br/>布罗艾',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab1/4.png',
					width: 104,
					height: 59
				},
				{
					id: 'tab1_5',
					name: 'UPPTÅG<br/>乌普托格',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab1/5.png',
					width: 97,
					height: 50
				},
				{
					id: 'tab1_6',
					name: 'FAMNIG HJÄRTA<br/>法姆尼 希亚塔',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab1/6.png',
					width: 105,
					height: 56
				},
				{
					id: 'tab1_7',
					name: 'HEJNINGE',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab1/7.png',
					width: 83,
					height: 49
				},
				{
					id: 'tab1_8',
					name: 'BYLLAN',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab1/8.png',
					width: 77,
					height: 66
				}
			],
			tabArr2: [
				{
					id: 'tab2_1',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab2/1.png',
					width: 80,
					height: 73
				},
				{
					id: 'tab2_2',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab2/2.png',
					width: 97,
					height: 93
				},
				{
					id: 'tab2_3',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab2/3.png',
					width: 90,
					height: 67
				},
				{
					id: 'tab2_4',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab2/4.png',
					width: 79,
					height: 70
				},
				{
					id: 'tab2_5',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab2/5.png',
					width: 73,
					height: 78
				},
				{
					id: 'tab2_6',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab2/6.png',
					width: 52,
					height: 68
				},
				{
					id: 'tab2_7',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab2/7.png',
					width: 42,
					height: 91
				},
				{
					id: 'tab2_8',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab2/8.png',
					width: 111,
					height: 39
				},
				{
					id: 'tab2_9',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab2/9.png',
					width: 65,
					height: 86
				},
				{
					id: 'tab2_10',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab2/10.png',
					width: 83,
					height: 62
				},
				{
					id: 'tab2_11',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab2/11.png',
					width: 66,
					height: 66
				}
			],
			tabArr3: [
				{
					id: 'tab3_1',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab3/1.png',
					width: 106,
					height: 79
				},
				{
					id: 'tab3_2',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab3/2.png',
					width: 112,
					height: 69
				},
				{
					id: 'tab3_3',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab3/3.png',
					width: 112,
					height: 77
				},
				{
					id: 'tab3_4',
					imgUrl: 'https://ikea-mrm.woaap.com/images/mask/diy/ntab3/4.png',
					width: 111,
					height: 36
				}
			],
			background: ['ikea food', 'ikea 大门', '卡莱克', '卧室'],
			smileAmbassador: ['狗', '鲨鱼', '猴子', '小熊'],
			content: []
		};
	},
	onShow() {
		getApp().td_app_sdk.event({
			id: 'diy',
			label: 'pv',
			params: {}
		});
	},
	onShareAppMessage: function(res) {
		return {
			title: '微笑传递爱心 和宜家玩在一起',
			path: 'pages/index/index',
			imageUrl: 'https://ikea-mrm.woaap.com/images/share/share_mask.jpg'
		};
	},
	onLoad(option) {
		console.log(option);
		// option.choose = '2'
		// option.nchoose = '2'
		this.nchoose = option.nchoose;
		this.content.push(this.background[parseInt(option.choose) - 1]);
		this.content.push(this.smileAmbassador[parseInt(option.nchoose) - 1]);
		console.log(this.content);
		this.diybg = `https://ikea-mrm.woaap.com/images/mask/choose/${option.choose}.png`;
		this.animal = `https://ikea-mrm.woaap.com/images/mask/nchoose/${option.nchoose}.png`;
		this.post = `https://ikea-mrm.woaap.com/images/mask/post/${option.choose}-${option.nchoose}.png`;
		let box = uni.createSelectorQuery().select('#box');
		let nbox = uni.createSelectorQuery().select('#smile1');
		box
			.boundingClientRect(res => {
				this.box = res;
				console.log(res);
			})
			.exec(() => {
				nbox
					.boundingClientRect(nres => {
						this.smileBox = nres;
						console.log(nres);
					})
					.exec(() => {});
			});
		new YrobotTouch(this.$scope, 'touch', {
			//会创建this.touch1指向实例对象
			touchStart: evt => {
				console.log(evt);
			},
			touchMove: () => {
				this.smileObj.angle = this.smileObj.angle;
				this.smileObj.zoom = this.smileObj.zoom;
				this.smileObj.left = this.smileObj.left;
				this.smileObj.top = this.smileObj.top;
			},
			touchEnd: function() {},
			touchCancel: function() {},
			multipointStart: function() {}, //一个手指以上触摸屏幕触发
			multipointEnd: function() {}, //当手指离开，屏幕只剩一个手指或零个手指触发(一开始只有一根手指也会触发)
			tap: function() {}, //点按触发，覆盖下方3个点击事件，doubleTap时触发2次
			doubleTap: function() {}, //双击屏幕触发
			longTap: function() {}, //长按屏幕750ms触发
			singleTap: function() {}, //单击屏幕触发，包括长按
			rotate: evt => {
				//evt.angle代表两个手指旋转的角度
				//console.log('rotate:' + evt.angle);
				this.smileObj.angle = this.smileObj.angle + evt.angle;
			},
			pinch: evt => {
				//evt.zoom代表两个手指缩放的比例(多次缩放的累计值),evt.singleZoom代表单次回调中两个手指缩放的比例

				this.smileObj.zoom = evt.zoom;
				if (this.smileObj.zoom * this.smileObj.width > this.smileBox.width) this.smileObj.zoom = this.smileBox.width / this.smileObj.width;
			},
			pressMove: evt => {
				//evt.deltaX和evt.deltaY代表在屏幕上移动的距离,evt.target可以用来判断点击的对象
				// console.log(evt.target);
				this.kouzhaoM(evt.deltaX, evt.deltaY);
			},
			swipe: function(evt) {
				//在touch结束触发，evt.direction代表滑动的方向 ['Up','Right','Down','Left']
				//console.log("swipe:" + evt.direction);
			}
		});
	},
	methods: {
		okay() {
			this.isshowpop = false;
			getApp().td_app_sdk.event({
				id: '确认1',
				label: 'click'
			});
		},
		chooseTab(index) {
			this.tabIndex = index;
			if (index == 1) {
				getApp().td_app_sdk.event({
					id: '笑容',
					label: 'click'
				});
			} else if (index == 2) {
				getApp().td_app_sdk.event({
					id: '装饰',
					label: 'click'
				});
			} else if (index == 3) {
				getApp().td_app_sdk.event({
					id: '文字',
					label: 'click'
				});
			}
		},
		chooseSmile(smile, name, index) {
			this.smileIndex = index;
			this.smileObj.name = name + (index + 1);
			this.smileObj.width = smile.width;
			this.smileObj.height = smile.height;
			this.smileObj.left = (this.smileBox.width - parseInt(smile.width)) / 2;
			this.smileObj.top = (this.smileBox.height - parseInt(smile.height)) / 2;
			this.smileObj.angle = 0;
			this.smileObj.zoom = 1;
			this.smileObj.imgUrl = smile.imgUrl;
		},
		chooseDemos(item, name, index) {
			this.index = this.index + 1;
			let obj = new Object();
			obj.id = `touch${this.index}`;
			obj.index = this.index;
			obj.imgurl = item.imgUrl;
			obj.start = `touch${this.index}.start`;
			obj.move = `touch${this.index}.move`;
			obj.cancel = `touch${this.index}.cancel`;
			obj.end = `touch${this.index}.end`;
			obj.width = item.width;
			obj.height = item.height;
			obj.zoom = 1;
			obj.left = (this.box.width - parseInt(item.width)) / 2;
			obj.top = (this.box.width - parseInt(item.width)) / 2;
			obj.angle = 0;
			obj.name = name + (index + 1);
			this.demos.push(obj);
			var index = (this.demos || []).findIndex(res => res.id === `touch${this.index}`);
			// console.log(this.demos)
			this.addTouch(`touch${this.index}`, index);
		},
		touch() {
			this.demoId = -1;
		},
		delDemo(index) {
			this.demos.splice(index, 1);
			console.log(index);
		},
		addTouch(id) {
			let index = (this.demos || []).findIndex(res => res.id === id);
			console.log(this.$scope);
			new YrobotTouch(this.$scope, id, {
				//会创建this.touch1指向实例对象
				touchStart: evt => {
					console.log(evt);
					index = (this.demos || []).findIndex(res => res.id === id);
					this.demoId = evt.currentTarget.id;
					if (evt.target.offsetLeft < 0 && evt.target.offsetTop < 0) {
						this.delDemo(index);
					}
				},
				touchMove: () => {
					this.demos[index].angle = this.demos[index].angle;
					this.demos[index].zoom = this.demos[index].zoom;
					this.demos[index].left = this.demos[index].left;
					this.demos[index].top = this.demos[index].top;
				},
				touchEnd: function() {},
				touchCancel: function() {},
				multipointStart: function() {}, //一个手指以上触摸屏幕触发
				multipointEnd: function() {}, //当手指离开，屏幕只剩一个手指或零个手指触发(一开始只有一根手指也会触发)
				tap: function() {}, //点按触发，覆盖下方3个点击事件，doubleTap时触发2次
				doubleTap: function() {}, //双击屏幕触发
				longTap: function() {}, //长按屏幕750ms触发
				singleTap: function() {}, //单击屏幕触发，包括长按
				rotate: evt => {
					//evt.angle代表两个手指旋转的角度
					//console.log('rotate:' + evt.angle);
					this.demos[index].angle = this.demos[index].angle + evt.angle;
				},
				pinch: evt => {
					//evt.zoom代表两个手指缩放的比例(多次缩放的累计值),evt.singleZoom代表单次回调中两个手指缩放的比例
					console.log('pinch:' + evt.zoom);
					this.pressView(index, 0, 0, evt.zoom);
					// this.demos[index].zoom = evt.zoom;
				},
				pressMove: evt => {
					//evt.deltaX和evt.deltaY代表在屏幕上移动的距离,evt.target可以用来判断点击的对象
					// console.log(evt.target);
					// console.log(evt.deltaX);
					this.pressView(index, evt.deltaX, evt.deltaY, this.demos[index].zoom);
				},
				swipe: function(evt) {
					//在touch结束触发，evt.direction代表滑动的方向 ['Up','Right','Down','Left']
					//console.log("swipe:" + evt.direction);
				}
			});
		},
		kouzhaoM(deltaX, deltaY) {
			let left = this.smileObj.left;
			let top = this.smileObj.top;
			// left += deltaX;
			left = left + deltaX;
			top += deltaY;
			if (left < 0) left = 0;
			if (top < 0) top = 0;
			if (left > this.smileBox.width - this.smileObj.width * this.smileObj.zoom) left = this.smileBox.width - this.smileObj.width * this.smileObj.zoom;
			if (top > this.smileBox.height - this.smileObj.height * this.smileObj.zoom) top = this.smileBox.height - this.smileObj.height * this.smileObj.zoom;
			this.smileObj.left = left;
			this.smileObj.top = top;
		},
		pressView(index, deltaX, deltaY, zoo) {
			let left = this.demos[index].left;
			let top = this.demos[index].top;
			let zoom = zoo;
			if (zoom * this.demos[index].width > this.box.width) zoom = this.box.width / this.demos[index].width;
			// left += deltaX;
			left += deltaX;
			top += deltaY;
			// console.log(left)
			if (left < 5) left = 5;
			if (top < 5) top = 5;
			if (left > this.box.width - 15 - this.demos[index].width * zoom) left = this.box.width - 15 - this.demos[index].width * zoom;
			if (top > this.box.height - 15 - this.demos[index].height * zoom) top = this.box.height - 15 - this.demos[index].height * zoom;
			if (left < 5) left = 5;
			if (top < 5) top = 5;
			// console.log(left)
			this.demos[index].left = left;
			this.demos[index].top = top;
			this.demos[index].zoom = zoom;
		},
		gopost() {
			getApp().td_app_sdk.event({
				id: '生成海报',
				label: 'click'
			});
			uni.showLoading({
				title: '为您生成海报'
			});
			let smileL = this.smileBox.left - this.box.left + this.smileObj.left;
			let smileT = this.smileBox.top - this.box.top + this.smileObj.top;

			this.content.push(this.smileObj.name); //记录用户选择的微笑名称
			this.palette.width = `${700 * this.canvasScale}rpx`;
			this.palette.height = `${1245 * this.canvasScale}rpx`;
			this.palette.views = [
				{
					type: 'image',
					url: 'https://ikea-mrm.woaap.com/images/mask/post/postbg1.png',
					css: {
						width: `${700 * this.canvasScale}rpx`,
						height: `${1245 * this.canvasScale}rpx`,
						left: 0,
						top: 0,
						rotate: 0
					}
				},
				//post宽度需要和diy海报的宽度一致
				this._image(this.post, `${644 * this.canvasScale}rpx`, `${866 * this.canvasScale}rpx`, 0, 0, 0),
				this._image(
					this.smileObj.imgUrl,
					`${this.smileObj.width * this.smileObj.zoom * this.canvasScale}px`,
					`${this.smileObj.height * this.smileObj.zoom * this.canvasScale}px`,
					smileL * this.canvasScale,
					smileT * this.canvasScale,
					this.smileObj.angle
				)
			];
			//将用户点击选择的图片发在画布里面生成图片
			this.demos.forEach((item, index) => {
				this.palette.views.push(
					this._image(
						item.imgurl,
						`${item.width * item.zoom * this.canvasScale}px`,
						`${item.height * item.zoom * this.canvasScale}px`,
						(item.left + 5) * this.canvasScale,
						(item.top + 5) * this.canvasScale,
						item.angle
					)
				);
				this.content.push(item.name);
			});
			this.palette.views.push(
				this._image(
					'https://ikea-mrm.woaap.com/images/mask/post/qrcode.png',
					`${600 * this.canvasScale}rpx`,
					`${242 * this.canvasScale}rpx`,
					43 * this.canvasScale,
					(520 / 680) * wx.getSystemInfoSync().windowWidth * this.canvasScale,
					0
				)
			);
			this.palette.views.push(
				this._image(
					'https://ikea-mrm.woaap.com/images/mask/post/q.png',
					`${51 * this.canvasScale}rpx`,
					`${46 * this.canvasScale}rpx`,
					(470 / 680) * wx.getSystemInfoSync().windowWidth * this.canvasScale,
					(755 / 680) * wx.getSystemInfoSync().windowWidth * this.canvasScale,
					0
				)
			);
			console.log(this.palette);
			this.$forceUpdate();
		},

		onImgOK(e) {
			console.log(e.detail.path);
			this.saveImgUrl = e.detail.path;

			//图片生成成功后记录游戏数据
			let fileSystemManager = wx.getFileSystemManager();
			fileSystemManager.readFile({
				filePath: e.detail.path,
				encoding: 'base64',
				success: data => {
					let base64 = 'data:image/png;base64,' + data.data;
					console.log(base64);
					wx.request({
						url: getApp().globalData.baseUrl + 'api/access.php?a=playgame',
						method: 'POST',
						header: {
							'content-type': 'application/x-www-form-urlencoded' //自定义请求头信息
						},
						data: {
							uid: getApp().globalData.uid,
							gamename: 'mask',
							content: this.content,
							basecode: data.data
						},
						success: res => {
							console.log(res);
							uni.hideLoading();
							this.demoId = -1;
							this.showStep4 = true;
							wx.setStorageSync('step4', 1);
							getApp().td_app_sdk.event({
								id: 'step4',
								label: 'pv',
								params: {}
							});
						}
					});
				}
			});

			//  wx.getImageInfo({
			// 	src: e.detail.path,
			// 	success:  (image) =>{
			// 		console.log(image)
			// 	}
			// });
			// 小程序读取文件管理器 api
			// let fileSystemManager = wx.getFileSystemManager()
			// fileSystemManager.readFile({
			//   filePath: e.detail.path,
			//   encoding: 'base64',
			//   success: (data)=>{
			// 	let base64 = 'data:image/png;base64,'+ data.data
			// 	console.log(base64)
			// 	// 自定义接口
			// 	// let { promise } = http.imgUpload( base64 )
			// 	// promise.then(resolve=>{
			// 	//   console.log(resolve)
			// 	//   callback && callback(filePath, temp_path)
			// 	  // wx.hideLoading()
			// 	// })
			//   }
			// })
			//  wx.getImageInfo({
			// 	src: e.detail.path,
			// 	success:  (image) =>{
			// 		this.getBase64Image(e.detail.path,image.width,image.height,(base64)=>{
			// 			console.log(base64)
			// 			this.saveImgUrl = base64
			// 			uni.hideLoading();
			// 			this.demoId = -1
			// 			this.showStep4 = true
			// 		})
			// 	}
			// });

			//  wx.request({
			// 	  url:  e.detail.path,
			// 	  method: 'GET',
			// 	  responseType: 'arraybuffer',
			// 	  success: (res) => {
			// 		let base64 = wx.arrayBufferToBase64(res.data);
			// 		let userImageBase64 = 'data:image/jpg;base64,' + base64;

			// 		console.log(userImageBase64)
			// 	  },
			// 	  fail(err) {
			// 		  console.log(err)
			// 	  	// uni.showToast({
			// 	  	// 	title:"错误错误"
			// 	  	// })
			// 	  }
			// })
		},
		onImgErr() {
			uni.showToast({
				title: '错误错误'
			});
		},
		_image(url, width, height, left, top, rotate) {
			return {
				type: 'image',
				url: url,
				css: {
					width: width,
					height: height,
					left: left + (25 / 680) * wx.getSystemInfoSync().windowWidth * this.canvasScale + 'px',
					top: top + (200 / 680) * wx.getSystemInfoSync().windowWidth * this.canvasScale + 'px',
					rotate: rotate
				}
			};
		},
		getSaveImgAuth() {
			getApp().td_app_sdk.event({
				id: '保存海报',
				label: 'click'
			});
			uni.showLoading({
				title: '请稍后',
				mask: true
			});
			uni.getSetting({
				success: res => {
					console.log(res);
					if (!res.authSetting['scope.writePhotosAlbum']) {
						uni.authorize({
							scope: 'scope.writePhotosAlbum',
							success: () => {
								//1.1 允许授权
								this.saveImg(this.saveImgUrl);
							},
							fail() {
								//1.2 拒绝授权
								// 授权失败
								uni.showModal({
									title: '警告',
									content: '您点击了拒绝授权,将无法正常保存图片,点击确定重新获取授权。',
									success: function(res) {
										if (res.confirm) {
											uni.openSetting({
												success: res => {
													uni.showToast({
														icon: 'success',
														title: '授权成功',
														duration: 2000
													});
												}
											});
										}
									}
								});
							}
						});
					} else {
						this.saveImg(this.saveImgUrl);
					}
				}
			});
		},
		saveImg(url) {
			uni.showLoading({
				title: '图片保存中',
				mask: true
			});
			uni.saveImageToPhotosAlbum({
				filePath: url,
				success: () => {
					uni.hideLoading();
					uni.showToast({
						icon: 'success',
						title: '保存成功',
						duration: 2000
					});
				},
				fail() {
					uni.hideLoading();
					uni.showToast({
						icon: 'none',
						title: '保存失败',
						duration: 2000
					});
				}
			});
		},
		goLight() {
			getApp().td_app_sdk.event({
				id: '点亮勋章',
				label: 'click'
			});
			uni.showLoading({
				title: '点亮勋章中',
				mask: true
			});
			wx.request({
				url: getApp().globalData.baseUrl + 'api/access.php?a=getmedal',
				method: 'POST',
				header: {
					'content-type': 'application/x-www-form-urlencoded' //自定义请求头信息
				},
				data: {
					uid: getApp().globalData.uid,
					gamename: 'mask'
				},
				success: res => {
					console.log(res.data.data);
					uni.hideLoading();
					uni.redirectTo({
						url: '/pages/mask/light?nownum=' + res.data.data.nownum
					});
				}
			});
		}
	}
};
</script>

<style lang="less">
.step4bg {
	position: fixed;
	top: 0;
	left: 0;
	right: 0;
	bottom: 0;
	z-index: 999;
	padding-top: 925rpx;
	box-sizing: border-box;
	text-align: center;
	.tips {
		width: 442rpx;
		height: 71rpx;
		margin: 0 auto;
	}
	.btngroup {
		width: 100vw;
		height: 144rpx;
		display: flex;
		justify-content: space-around;
		flex-direction: row;
		margin-top: 40rpx;
		img {
			width: 346rpx;
			height: 144rpx;
		}
	}
	.popup {
		position: absolute;
		top: 0;
		left: 0;
		width: 100%;
		height: 100%;
		background: rgba(0, 0, 0, 0.65);
		display: flex;
		justify-content: center;
		align-items: center;
		.popmain {
			width: 580rpx;
			height: 770rpx;
			background: #ffffff;
			border-radius: 30rpx;
			display: flex;
			flex-direction: column;
			align-items: center;
			position: relative;
			.close {
				position: absolute;
				top: 40rpx;
				right: 56rpx;
				width: 30rpx;
				height: 30rpx;
			}
			.popicon {
				width: 421rpx;
				height: 376rpx;
				margin-top: 86rpx;
			}
			.btn {
				width: 346rpx;
				height: 144rpx;
				margin-top: 90rpx;
			}
		}
	}
}
.demosActived {
	border: 4rpx solid #fcf08b !important;
}
.item_actived {
	border: 2rpx solid #29ddd6 !important;
}
.painter {
	position: absolute;
	top: 100vh;
	left: 0;
}
.bottombox {
	width: 100%;
	position: absolute;
	top: 940rpx;
	bottom: 0;
	left: 0;
	box-sizing: border-box;
	background: #ffffff;
	.tabs {
		width: 100%;
		height: 50rpx;
		display: flex;
		flex-direction: row;
		justify-content: center;
		align-items: center;
		box-sizing: border-box;
		position: absolute;
		top: -48rpx;
		.tab-item {
			width: 160rpx;
			height: 100%;
			display: flex;
			justify-content: center;
			align-items: flex-end;
			.tab1 {
				width: 155rpx !important;
				height: 48rpx !important;
			}
			img {
				width: 151rpx;
				height: 50rpx;
			}
		}
		.border {
			height: 50%;
			border-left: 2rpx solid #dddddd;
			border-radius: 10rpx;
			margin-top: -5rpx;
		}
	}
	.tab-content {
		width: 100vw;
		height: 260rpx;
		background: #ffffff;
		border-top: 2rpx solid #dddddd;
		display: flex;
		justify-content: center;
		align-items: center;
		.content-list {
			width: 90vw;
			height: 220rpx;
			box-sizing: border-box;
			display: flex;
			overflow-x: scroll;
			.content-item {
				flex-shrink: 0;
				width: 150rpx;
				height: 150rpx;
				margin-right: 15rpx;
				margin-top: 15rpx;
				border: 2rpx solid #e4e4e4;
				box-sizing: border-box;
				border-radius: 15rpx;
				padding: 20rpx 15rpx;
				position: relative;
				// .img{
				// 	width: 100rpx!important;
				// 	height: 100rpx!important;
				// 	margin: 0 auto;
				// 	display: block;
				// 	position: absolute;
				// 	top: 0;
				// 	left: 50%;
				// 	transform: translate(-50%,0);
				// }
				.smile-img {
					width: 100%;
					height: 70rpx;
					display: flex;
					justify-content: center;
					align-items: center;
				}
				.name {
					width: 100%;
					height: 30rpx;
					font-size: 16rpx;
					font-family: '黑体';
					color: #999999;
					text-align: left;
					position: absolute;
					bottom: 7rpx;
					font-weight: bold;
					line-height: 20rpx;
					display: flex;
					justify-content: flex-start;
					align-items: flex-end;
				}
			}
			.content-item2 {
				flex-shrink: 0;
				width: 150rpx;
				height: 150rpx;
				margin-right: 15rpx;
				margin-top: 15rpx;
				border: 2rpx solid #e4e4e4;
				box-sizing: border-box;
				border-radius: 15rpx;
				position: relative;
				display: flex;
				justify-content: center;
				align-items: center;

				.img {
					width: 100rpx !important;
					height: 100rpx !important;
					display: block;
				}
			}
		}
	}
}
.gopost {
	width: 138rpx;
	height: 138rpx;
	position: absolute;
	top: 750rpx;
	left: 602rpx;
}
.swiperbox {
	width: 644rpx;
	height: 651rpx;
	// width:660rpx;
	// height: 667rpx;
	position: relative;
	overflow: hidden;
	margin: 180rpx auto;

	.diybg {
		position: absolute;
		// width:613rpx;
		// height:626rpx;
		width: 612rpx;
		height: 624rpx;
		// top: 28rpx;
		top: 16rpx;
		left: 50%;
		transform: translate(-50%, 0);
	}
	.demos {
		position: absolute;
		box-sizing: border-box;
		.dimg {
			position: absolute;
			top: 50%;
			left: 50%;
			transform: translate(-50%, -50%);
		}
		.close {
			position: absolute;
			width: 42rpx;
			height: 42rpx;
			top: -21rpx;
			left: -21rpx;
			z-index: 999999;
		}
	}

	.smile1 {
		width: 300rpx;
		height: 210rpx;
		position: absolute;
		top: 345rpx;
		left: 50%;
		transform: translate(-50%, 0);
		img {
			position: absolute;
		}
	}
	.smile2 {
		width: 300rpx;
		height: 210rpx;
		position: absolute;
		top: 345rpx;
		left: 50%;
		transform: translate(-50%, 0);
		img {
			position: absolute;
		}
	}
	.smile3 {
		width: 250rpx;
		height: 180rpx;
		position: absolute;
		top: 345rpx;
		left: 50%;
		transform: translate(-50%, 0);
		img {
			position: absolute;
		}
	}
	.smile4 {
		width: 300rpx;
		height: 210rpx;
		position: absolute;
		top: 300rpx;
		left: 50%;
		transform: translate(-50%, 0);
		img {
			position: absolute;
		}
	}
}

.choose {
	width: 100vw;
	height: 100vh;
	background: #f4f4f4;
	position: relative;
	.choosebg {
		width: 100vw;
		height: 100vh;
		background: url(https://ikea-mrm.woaap.com/images/mask/choose.jpg) no-repeat;
		background-size: 100%;
		position: absolute;
		top: 50rpx;
		left: 0;
		text-align: center;
		.title {
			width: 405rpx;
			height: 81rpx;
			position: absolute;
			top: 60rpx;
			left: 50%;
			transform: translate(-50%, 0);
		}
		.step4 {
			width: 331rpx;
			height: 81rpx;
			position: absolute;
			top: 60rpx;
			left: 50%;
			transform: translate(-50%, 0);
		}
	}
}
</style>
